// 001 visual livebindings

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

unit u_vlb_08_tbindsourcedb;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.Bind.EngExt, Vcl.Bind.DBEngExt,
  System.Rtti, System.Bindings.Outputs, Vcl.Bind.Editors, Data.Bind.Components,
  Vcl.StdCtrls, Vcl.Bind.Grid, Data.Bind.Grid, Vcl.Grids, Vcl.ExtCtrls,
  Data.Bind.DBScope, Data.DB, Datasnap.DBClient, Vcl.Buttons, Vcl.Bind.Navigator;

type
  TForm1 = class(TForm)
    ClientDataSet1: TClientDataSet;
    BindSourceDB1: TBindSourceDB;
    EditCategory: TEdit;
    LinkControlToField1: TLinkControlToField;
    BindingsList1: TBindingsList;
    MemoNotes: TMemo;
    LinkControlToField2: TLinkControlToField;
    ImageGraphic: TImage;
    LinkControlToField3: TLinkControlToField;
    StringGridBindSourceDB1: TStringGrid;
    LinkGridToDataSource1: TLinkGridToDataSource;
    BindNavigator1: TBindNavigator;
    ClientDataSet1Category: TStringField;
    ClientDataSet1SpeciesName: TStringField;
    ClientDataSet1Lengthcm: TFloatField;
    ClientDataSet1Length_In: TFloatField;
    ClientDataSet1Common_Name: TStringField;
    ClientDataSet1Notes: TMemoField;
    ClientDataSet1Graphic: TBlobField;
    BindExpression1: TBindExpression;
    Edit1: TEdit;
    procedure BindSourceDB1SubDataSourceDataChange(Sender: TObject;
      Field: TField);
    procedure ClientDataSet1AfterScroll(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.BindSourceDB1SubDataSourceDataChange(Sender: TObject;
  Field: TField);
begin
  Caption:= Caption+ 'a';
  BindingsList1.Notify(ClientDataSet1, '');
end;

procedure TForm1.ClientDataSet1AfterScroll(DataSet: TDataSet);
begin
  Caption:= Caption+ 'c';
  BindingsList1.Notify(ClientDataSet1Length_In, '');
end;

end.
